import numpy as np
from scipy.linalg import schur


def solve_cts_riccati_schur(A, B, Q, Rinv):
    """
    Solve via Schur decomposition.
    :param A:
    :param B:
    :param Q:
    :param Rinv:
    :return:
    """
    m12 = -B.dot(Rinv).dot(B.T)
    M = np.block([[A, m12], [-Q, -A.T]])
    T, U = schur(M, sort='lhp')[:2]
    n = A.shape[0]
    U11 = U.T[:n, :n]
    U12 = U.T[:n, n:]
    P = U12.T.dot(np.linalg.inv(U11).T)
    return P
